/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: kernel.h 837 2012-12-26 15:09:59Z ertl-hiro $
 */

/*
 *		TOPPERS/HRPͥ ɸإåե
 *
 *  TOPPERS/HRPͥ뤬ݡȤ륵ӥȡɬפʥǡ
 *  ޥޤإåե롥
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤˤꡤޥʳ
 *  褦ˤʤäƤ롥
 *
 *  Υե򥤥󥯥롼ɤ˥󥯥롼ɤƤ٤ե
 *  Ϥʤ
 */

#ifndef TOPPERS_KERNEL_H
#define TOPPERS_KERNEL_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	TOPPERS̤Υǡޥ
 */
#include <t_stddef.h>

/*
 *  åȰ¸
 */
#include "target_kernel.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǡ
 */

/*
 *  ӥåȥѥ䥪ֹ֥η
 */
typedef	uint_t		TEXPTN;		/* 㳰װΥӥåȥѥ */
typedef	uint_t		FLGPTN;		/* ٥ȥե饰Υӥåȥѥ */
typedef	ulong_t		OVRTIM;		/* ץå */
typedef	uint_t		INTNO;		/* ֹ */
typedef	uint_t		INHNO;		/* ߥϥɥֹ */
typedef	uint_t		EXCNO;		/* CPU㳰ϥɥֹ */

/*
 *  ñ̤η
 */
typedef void	(*TASK)(intptr_t exinf);
typedef void	(*TEXRTN)(TEXPTN texptn, intptr_t exinf);
typedef void	(*CYCHDR)(intptr_t exinf);
typedef void	(*ALMHDR)(intptr_t exinf);
typedef void	(*OVRHDR)(ID tskid, intptr_t exinf);
typedef void	(*ISR)(intptr_t exinf);
typedef void	(*INTHDR)(void);
typedef void	(*EXCHDR)(void *p_excinf);
typedef ER_UINT	(*EXTSVC)(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid);
typedef void	(*INIRTN)(intptr_t exinf);
typedef void	(*TERRTN)(intptr_t exinf);

/*
 *  ΰݤΤη
 */
#ifndef TOPPERS_STK_T
#define TOPPERS_STK_T	intptr_t
#endif /* TOPPERS_STK_T */
typedef	TOPPERS_STK_T	STK_T;	/* åΰݤ뤿η */

#ifndef TOPPERS_MPF_T
#define TOPPERS_MPF_T	intptr_t
#endif /* TOPPERS_MPF_T */
typedef	TOPPERS_MPF_T	MPF_T;	/* Ĺסΰݤ뤿η */

/*
 *  åإåη
 */
typedef	struct t_msg {			/* ᡼ܥåΥåإå */
	struct t_msg	*pk_next;
} T_MSG;

typedef	struct t_msg_pri {		/* ͥդåإå */
	T_MSG	msgque;				/* åإå */
	PRI		msgpri;				/* åͥ */
} T_MSG_PRI;

/*
 *  ѥåȷ
 */
typedef struct t_rtsk {
	STAT	tskstat;	/*  */
	PRI		tskpri;		/* θͥ */
	PRI		tskbpri;	/* Υ١ͥ */
	STAT	tskwait;	/* Ԥװ */
	ID		wobjid;		/* ԤоݤΥ֥ȤID */
	TMO		lefttmo;	/* ॢȤޤǤλ */
	uint_t	actcnt;		/* ư׵ᥭ塼󥰿 */
	uint_t	wupcnt;		/* ׵ᥭ塼󥰿 */
	bool_t	texmsk;		/* 㳰ޥ֤ݤ */
	bool_t	waifbd;		/* Ԥػ߾֤ݤ */
	uint_t	svclevel;	/* ĥӥΥͥȥ٥ */
} T_RTSK;

typedef struct t_rtex {
	STAT	texstat;	/* 㳰ξ */
	TEXPTN	pndptn;		/* α㳰װ */
} T_RTEX;

typedef struct t_rsem {
	ID		wtskid;		/* ޥեԤƬΥIDֹ */
	uint_t	semcnt;		/* ޥեθߤλ񸻿 */
} T_RSEM;

typedef struct t_rflg {
	ID		wtskid;		/* ٥ȥե饰ԤƬΥIDֹ */
	FLGPTN	flgptn;		/* ٥ȥե饰θߤΥӥåȥѥ */
} T_RFLG;

typedef struct t_rdtq {
	ID		stskid;		/* ǡ塼ԤƬΥIDֹ */
	ID		rtskid;		/* ǡ塼μԤƬΥIDֹ */
	uint_t	sdtqcnt;	/* ǡ塼ΰ˳ǼƤǡο */
} T_RDTQ;

typedef struct t_rpdq {
	ID		stskid;		/* ͥ٥ǡ塼ԤƬΥ
						   IDֹ */
	ID		rtskid;		/* ͥ٥ǡ塼μԤƬΥ
						   IDֹ */
	uint_t	spdqcnt;	/* ͥ٥ǡ塼ΰ˳ǼƤǡ
						   ο */
} T_RPDQ;

typedef struct t_rmtx {
	ID		htskid;		/* ߥ塼ƥååƤ륿IDֹ */
	ID		wtskid;		/* ߥ塼ƥåԤƬΥIDֹ */
} T_RMTX;

typedef struct t_rmpf {
	ID		wtskid;		/* ĹסԤƬΥ
						   IDֹ */
	uint_t	fblkcnt;	/* Ĺסΰζΰ˳
						   դ뤳ȤǤĹ֥åο */
} T_RMPF;

typedef struct t_rcyc {
	STAT	cycstat;	/* ϥɥư */
	RELTIM	lefttim;	/* ˼ϥɥưޤǤл */
} T_RCYC;

typedef struct t_ralm {
	STAT	almstat;	/* 顼ϥɥư */
	RELTIM	lefttim;	/* 顼ϥɥưޤǤл */
} T_RALM;

typedef struct t_rovr {
	STAT	ovrstat;	/* Хϥɥư */
	OVRTIM	leftotm;	/* Ĥץå */
} T_ROVR;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ӥƽФΤ
 */
#include <kernel_fncode.h>				/* ǽɤ */
#include "target_svc.h"					/* եȥߤˤƽФ */
#include <svc_call.h>					/* ؿƽФˤƽФ */

#define SVC_CALL(svc)	_kernel_##svc	/* ؿƽФˤƤӽФ̾ */

/*
 *  ֥°
 */
#define TA_ACT			UINT_C(0x02)	/* ư줿֤ */

#define TA_TPRI			UINT_C(0x01)	/* Ԥͥٽ */
#define TA_MPRI			UINT_C(0x02)	/* å塼ͥٽ */

#define TA_WMUL			UINT_C(0x02)	/* ʣԤ */
#define TA_CLR			UINT_C(0x04)	/* ٥ȥե饰Υꥢ */

#define TA_CEILING		UINT_C(0x03)	/* ͥپ¥ץȥ */

#define TA_STA			UINT_C(0x02)	/* ϥɥư֤ */

#define	TA_NOWRITE		UINT_C(0x01)	/* ߥػ */
#define	TA_NOREAD		UINT_C(0x02)	/* ɽФػ */
#define	TA_EXEC			UINT_C(0x04)	/* ¹ԥ */
#define	TA_MEMINI		UINT_C(0x08)	/* νԤ */
#define	TA_MEMPRSV		UINT_C(0x10)	/* νԤʤ */
#define	TA_SDATA		UINT_C(0x20)	/* 硼ȥǡΰ */
#define	TA_UNCACHE		UINT_C(0x40)	/* åԲ */
#define	TA_IODEV		UINT_C(0x80)	/* եǥХΰ */

#define TA_NONKERNEL	UINT_C(0x02)	/* ͥγ */

#define TA_ENAINT		UINT_C(0x01)	/* ׵ػߥե饰򥯥ꥢ */
#define TA_EDGE			UINT_C(0x02)	/* åȥꥬ */

/*
 *  ӥư⡼ɤ
 */
#define TWF_ORW			UINT_C(0x01)	/* ٥ȥե饰ORԤ */
#define TWF_ANDW		UINT_C(0x02)	/* ٥ȥե饰ANDԤ */

#define	TPM_WRITE		UINT_C(0x01)	/* ߥΥå */
#define	TPM_READ		UINT_C(0x02)	/* ɽФΥå */
#define	TPM_EXEC		UINT_C(0x04)	/* ¹ԥΥå */

/*
 *  ֥Ȥξ֤
 */
#define TTS_RUN			UINT_C(0x01)	/* ¹Ծ */
#define TTS_RDY			UINT_C(0x02)	/* ¹Բǽ */
#define TTS_WAI			UINT_C(0x04)	/* Ԥ */
#define TTS_SUS			UINT_C(0x08)	/* Ԥ */
#define TTS_WAS			UINT_C(0x0c)	/* Ԥ */
#define TTS_DMT			UINT_C(0x10)	/* ٻ߾ */

#define TTW_SLP			UINT_C(0x0001)	/* Ԥ */
#define TTW_DLY			UINT_C(0x0002)	/* ַвԤ */
#define TTW_SEM			UINT_C(0x0004)	/* ޥեλ񸻳Ԥ */
#define TTW_FLG			UINT_C(0x0008)	/* ٥ȥե饰Ԥ */
#define TTW_SDTQ		UINT_C(0x0010)	/* ǡ塼ؤԤ */
#define TTW_RDTQ		UINT_C(0x0020)	/* ǡ塼μԤ */
#define TTW_SPDQ		UINT_C(0x0100)	/* ͥ٥ǡ塼ؤԤ */
#define TTW_RPDQ		UINT_C(0x0200)	/* ͥ٥ǡ塼μԤ */
#define TTW_MTX			UINT_C(0x0080)	/* ߥ塼ƥåΥåԤ */
#define TTW_MPF			UINT_C(0x2000)	/* Ĺ֥åγԤ */

#define TTEX_ENA		UINT_C(0x01)	/* 㳰ľ */
#define TTEX_DIS		UINT_C(0x02)	/* 㳰ػ߾ */

#define TCYC_STP		UINT_C(0x01)	/* ϥɥ餬ưƤʤ */
#define TCYC_STA		UINT_C(0x02)	/* ϥɥ餬ưƤ */

#define TALM_STP		UINT_C(0x01)	/* 顼ϥɥ餬ưƤʤ */
#define TALM_STA		UINT_C(0x02)	/* 顼ϥɥ餬ưƤ */

#define TOVR_STP		UINT_C(0x01)	/* Хϥɥ餬ưƤʤ*/
#define TOVR_STA		UINT_C(0x02)	/* Хϥɥ餬ưƤ */

/*
 *  ݸɥᥤID
 */
#define TDOM_SELF		0				/* °ݸɥᥤ */
#define TDOM_KERNEL		(-1)			/* ͥɥᥤ */
#define TDOM_NONE		(-2)			/* ̵°ݸɥᥤ°ʤ*/

/*
 *  ¾
 */
#define TSK_SELF		0			/*  */
#define TSK_NONE		0			/* 륿ʤ */

#define TPRI_SELF		0			/* Υ١ͥ */
#define TPRI_INI		0			/* εưͥ */

#define TIPM_ENAALL		0			/* ͥ٥ޥ */

/*
 *  ȥޥ
 */

/*
 *  ݡȤ뵡ǽ
 */
#ifdef TOPPERS_TARGET_SUPPORT_DIS_INT
#define TOPPERS_SUPPORT_DIS_INT			/* dis_intݡȤƤ */
#endif /* TOPPERS_TARGET_SUPPORT_DIS_INT */

#ifdef TOPPERS_TARGET_SUPPORT_ENA_INT
#define TOPPERS_SUPPORT_ENA_INT			/* ena_intݡȤƤ */
#endif /* TOPPERS_TARGET_SUPPORT_ENA_INT */

#ifdef TOPPERS_TARGET_SUPPORT_GET_UTM
#define TOPPERS_SUPPORT_GET_UTM			/* get_utmݡȤƤ */
#endif /* TOPPERS_TARGET_SUPPORT_GET_UTM */

#define TOPPERS_SUPPORT_MUTEX			/* ߥ塼ƥåǽĥ */

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
#define TOPPERS_SUPPORT_OVRHDR			/* Хϥɥ鵡ǽĥ */
#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#define TOPPERS_SUPPORT_PROTECT			/* ݸǽбΥͥ */

#ifdef TOPPERS_TARGET_SUPPORT_ATT_MOD
#define TOPPERS_SUPPORT_ATT_MOD			/* ATT_MODݡȤƤ */
#endif /* TOPPERS_TARGET_SUPPORT_ATT_MOD */

#ifdef TOPPERS_TARGET_SUPPORT_ATT_PMA
#define TOPPERS_SUPPORT_ATT_PMA			/* ATT_PMAݡȤƤ */
#endif /* TOPPERS_TARGET_SUPPORT_ATT_PMA */

/*
 *  ͥ٤ϰ
 */
#define TMIN_TPRI		1			/* ͥ٤κǾ͡ʺǹ͡*/
#define TMAX_TPRI		16			/* ͥ٤κ͡ʺ͡*/
#define TMIN_DPRI		1			/* ǡͥ٤κǾ͡ʺǹ͡*/
#define TMAX_DPRI		16			/* ǡͥ٤κ͡ʺ͡*/
#define TMIN_MPRI		1			/* åͥ٤κǾ͡ʺǹ͡*/
#define TMAX_MPRI		16			/* åͥ٤κ͡ʺ͡*/
#define TMIN_ISRPRI		1			/* ߥӥ롼ͥ٤κǾ */
#define TMAX_ISRPRI		16			/* ߥӥ롼ͥ٤κ */

/*
 *  С
 */
#define TKERNEL_MAKER	UINT_C(0x0118)	/* ͥΥ᡼ */
#define TKERNEL_PRID	UINT_C(0x0006)	/* ͥμֹ */
#define TKERNEL_SPVER	UINT_C(0xf515)	/* ͥͤΥСֹ */
#define TKERNEL_PRVER	UINT_C(0x2010)	/* ͥΥСֹ */

/*
 *  塼󥰲κ
 */
#define TMAX_ACTCNT		UINT_C(1)		/* ư׵ᥭ塼󥰿κ */
#define TMAX_WUPCNT		UINT_C(1)		/* ׵ᥭ塼󥰿κ */

/*
 *  ӥåȥѥΥӥåȿ
 */
#ifndef TBIT_TEXPTN					/* 㳰װΥӥåȿ */
#define TBIT_TEXPTN		(sizeof(TEXPTN) * CHAR_BIT)
#endif /* TBIT_TEXPTN */

#ifndef TBIT_FLGPTN					/* ٥ȥե饰Υӥåȿ */
#define TBIT_FLGPTN		(sizeof(FLGPTN) * CHAR_BIT)
#endif /* TBIT_FLGPTN */

/*
 *  ץå֡OVRTIMˤκ
 */
#ifndef TMAX_OVRTIM
#define TMAX_OVRTIM		ULONG_MAX
#endif /* TMAX_OVRTIM */

/*
 *  ΰݤΤΥޥ
 *
 *  ʲTOPPERS_COUNT_SZTOPPERS_ROUND_SZϡunit2ζҾǤ
 *  뤳ȤꤷƤ롥
 */
#ifndef TOPPERS_COUNT_SZ
#define TOPPERS_COUNT_SZ(sz, unit)	(((sz) + (unit) - 1) / (unit))
#endif /* TOPPERS_COUNT_SZ */
#ifndef TOPPERS_ROUND_SZ
#define TOPPERS_ROUND_SZ(sz, unit)	(((sz) + (unit) - 1) & ~((unit) - 1))
#endif /* TOPPERS_ROUND_SZ */

#define COUNT_STK_T(sz)		TOPPERS_COUNT_SZ(sz, sizeof(STK_T))
#define ROUND_STK_T(sz)		TOPPERS_ROUND_SZ(sz, sizeof(STK_T))

#define COUNT_MPF_T(blksz)	TOPPERS_COUNT_SZ(blksz, sizeof(MPF_T))
#define ROUND_MPF_T(blksz)	TOPPERS_ROUND_SZ(blksz, sizeof(MPF_T))

/*
 *  ¾ι
 */
#define TMAX_MAXSEM		UINT_MAX	/* ޥեκ񸻿κ */

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_KERNEL_H */
