/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  ޥɥ饤СSTM32P207ѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR

/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
void
target_ovrtimer_initialize(intptr_t exinf)
{
    /*  */
	sil_orw((void*)RCC_APB1ENR, APB1ENR_TIM2_EN);
    sil_wrh_mem((void *)TIMX_CR1(OVRTIMER_BASE), (CR1_OPM | CR1_DIR));
    sil_wrh_mem((void *)TIMX_PSC(OVRTIMER_BASE), (SYS_CLOCK / 1000000));
    sil_orh((void *)TIMX_EGR(OVRTIMER_BASE), EGR_UG);
    sil_andh((void *)TIMX_SR(OVRTIMER_BASE), ~SR_UIF);
    /* ߵ */
    sil_wrh_mem((void *)TIMX_DIER(OVRTIMER_BASE), DIER_UIE);
}

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
void
target_ovrtimer_terminate(intptr_t exinf)
{
    /* ޤ */
    sil_andh((void *)TIMX_CR1(OVRTIMER_BASE), ~CR1_CEN);

    /* ׵򥯥ꥢ */
    sil_andh((void *)TIMX_SR(OVRTIMER_BASE), ~SR_UIF);
}

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
void
target_ovrtimer_start(OVRTIM ovrtim)
{
	CLOCK	 cyc = OVRTIMER_CLOCK(ovrtim) - 1;

    /*
     *  ޼ꤷޤư򳫻Ϥ롥
     */
    assert(cyc <= MAX_OVRTIMER_CLOCK);          /* ޾ͤΥå */

    sil_wrw_mem((void *)TIMX_CNT(OVRTIMER_BASE), cyc);   /* 󥿡򥻥å */

    /* ׵򥯥ꥢ */
    sil_andh((void *)TIMX_SR(OVRTIMER_BASE), ~SR_UIF);

    /* ޥ */
    sil_orh((void *)TIMX_CR1(OVRTIMER_BASE), CR1_CEN);
}

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
OVRTIM
target_ovrtimer_stop(void)
{
    OVRTIM rest;

    /* ޤ */
    sil_andh((void *)TIMX_CR1(OVRTIMER_BASE), ~CR1_CEN);
    /* ׵򥯥ꥢ */
    sil_andh((void *)TIMX_SR(OVRTIMER_BASE), ~SR_UIF);

	rest = (OVRTIM)sil_rew_mem((void *)TIMX_CNT(OVRTIMER_BASE));

    if(rest < 0){
        return 1;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥ޤλĤ֤ɽФ
 */
OVRTIM
target_ovrtimer_get_current(void)
{
    OVRTIM rest;

	rest = (OVRTIM)sil_rew_mem((void *)TIMX_CNT(OVRTIMER_BASE));

    if(rest < 0){
        return 0;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥޳ߥϥɥ
 */
void
target_ovrtimer_handler(void)
{
	i_begin_int(INTNO_OVRTIMER);
	call_ovrhdr();
	i_end_int(INTNO_OVRTIMER);
}

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */


